| 	Gestion du clavier sous interruptions

	.text

	.globl	_I_InitInterrupts
	.globl	_I_ShutdownInterrupts
	.globl	_atari_CtrlCPressed

	.globl	_atari_event

| -----	Installation des interruptions

_I_InitInterrupts:
	movew	#0x2700,sr

	movel	0x4ba:w,basetime
	movel	0x4ba:w,currenttime

	clrw	atari_mouseb
	clrw	atari_mousex
	clrw	atari_mousey
	clrw	_atari_CtrlCPressed
	
	moveml	d0/a0-a1,sp@-

	moveql	#127,d0
	lea	_atari_clavier,a0
Ikbd_bcl:
	clrb	a0@+
	dbra	d0,Ikbd_bcl

	moveml	sp@+,d0/a0-a1

	movel	0xfffffa06:w,old_mfp
|	clr.l	($fffffa06).w

|	bset	#3,0xfffffa17:w	| Software end of interrupt

	movel	0x118:w,old_ikbd
	movel	#ikbd,0x118:w
	bset	#6,0xfffffa09:w	| IERB
	bset	#6,0xfffffa15:w	| IMRB

	movel	0x70:w,old_vbl
	movel	#vbl,0x70:w

	moveb	#8,0xfffffc02:w

	movew	#0x2300,sr
	rts

| ----- Restauration ancienne routine

_I_ShutdownInterrupts:
	movew	#0x2700,sr

	movel	old_mfp,0xfffffa06:w
	movel	old_ikbd,0x118:w
	movel	old_vbl,0x70:w

ikbd_videbuffer:
	btst	#0,0xfffffc00:w
	beq	ikbd_finbuffer
	tstb	0xfffffc02:w
	bra	ikbd_videbuffer
ikbd_finbuffer:

	movew	#0x2300,sr
	rts

	.data
	.even
	.comm	old_ikbd,4*1
	.even
	.comm	old_mfp,4*1
	.even
	.comm	old_vbl,4*1

	.even
	.comm	basetime,4*1
	.even
	.comm	currenttime,4*1

| ----- Routine sous interruption

	.text
vbl:
	movel	0x4ba:w,currenttime
	jmp	@(old_vbl)@()

ikbd:
	moveml	d0-d2/a0-a1,sp@-
	lea	_atari_clavier,a0
	moveb	0xfffffc02:w,d0

	cmpb	#0xff,d0
	beq	ikbd_yes_joystick

	cmpb	#0xf8,d0
	bmi	ikbd_no_mouse
	cmpb	#0xfb,d0
	bpl	ikbd_no_mouse

ikbd_yes_mouse:
	andw	#3,d0
	movew	d0,atari_mouseb

	movel	#ikbd_mousex,0x118:w
	bra	ikbd_fin

ikbd_yes_joystick:
	movel	#ikbd_joystick,0x118:w
	bra	ikbd_fin

ikbd_no_mouse:
	moveb	d0,d1
	andl	#0x7f,d1
	moveb	d0,d2
	tas	d2
	spl	a0@(0,d1:w)

	| d0 bit 7=0 : touche lachee,=1: touche presse
	| d1 scancode de la touche

	lea	scancodes,a0
	moveb	a0@(0,d1:w),d1
	lea	_atari_event,a0
	clrl	a0@			| 0 = touche relache
	btst	#7,d0
	beq	ikbd_kd
	movel	#1,a0@			| 1 = touche appuye
ikbd_kd:
	movel	d1,a0@(4)		| Numero de la touche
	clrl	a0@(8)
	clrl	a0@(12)

	movel	a0,sp@-
	jsr	_D_PostEvent
	addql	#4,sp
ikbd_fin:

	| Tester si Ctrl + C appuye

	tstb	_atari_clavier+0x1d	| Control ?
	beq	ikbd_noctrlc
	tstb	_atari_clavier+0x2e	| C ?
	beq	ikbd_noctrlc
	movew	#0xffff,_atari_CtrlCPressed
ikbd_noctrlc:

	| Fin interruption

	moveml	sp@+,d0-d2/a0-a1
	bclr	#6,0xfffffa11:w
	rte

ikbd_mousex:
	movel	d0,sp@-

	moveb	0xfffffc02:w,d0
	extw	d0
	addw	d0,atari_mousex

	movel	sp@+,d0

	movel	#ikbd_mousey,0x118:w
	bclr	#6,0xfffffa11:w
	rte

ikbd_mousey:
	movel	d0,sp@-

	moveb	0xfffffc02:w,d0
	extw	d0
	subw	d0,atari_mousey

	movel	sp@+,d0

	movel	#ikbd,0x118:w
	bclr	#6,0xfffffa11:w
	rte

ikbd_joystick:
	movel	d0,sp@-

	moveb	0xfffffc02:w,d0

	movel	sp@+,d0
	movel	#ikbd,0x118:w
	bclr	#6,0xfffffa11:w
	rte

| Code ASCII ou SCANCODE + 0x80

	.data

	.comm	_atari_clavier,128
	.even
	.comm	_atari_CtrlCPressed,2*1
	.even
	.comm	atari_mousex,2*1
	.even
	.comm	atari_mousey,2*1
	.even
	.comm	atari_mouseb,2*1

	.data
scancodes:
	.byte	0x00,0x1b,0x31,0x32,0x33,0x34,0x35,0x36
	.byte	0x37,0x38,0x39,0x30,0x2d,0x3d,0x08,0x09

	.byte	0x71,0x77,0x65,0x72,0x74,0x79,0x75,0x69
	.byte	0x6f,0x70,0x7b,0x7d,0x0d,0x9d,0x61,0x73

	.byte	0x64,0x66,0x67,0x68,0x6a,0x6b,0x6c,0x3b
	.byte	0x27,0x60,0xb6,0x7c,0x7a,0x78,0x63,0x76

	.byte	0x62,0x6e,0x6d,0x2c,0x2e,0x2f,0xb6,0x00
	.byte	0xb8,0x20,0xba,0xbb,0xbc,0xbd,0xbe,0xbf


	.byte	0xc0,0xc1,0xc2,0xc3,0xc4,0x00,0x00,0xc7
	.byte	0xc8,0x00,0x2d,0xcb,0x00,0xcd,0x2b,0x00

	.byte	0xd0,0x00,0xd2,0x7f,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00

	.byte	0x00,0xe1,0xe2,0x28,0x29,0x2f,0x2a,0x37
	.byte	0x38,0x39,0x34,0x35,0x36,0x31,0x32,0x33

	.byte	0x30,0x2e,0x0d,0x00,0x00,0x00,0x00,0x00
	.byte	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00

